#include <iostream>
#include <cstring>
#include <vector>
#include <string>
#include <ios>

using namespace std;

void shift(int n, char* x){
    char temp = x[1];
    for(int i = 1; i < n; i++)
        x[i] = x[i+1];
    x[n] = temp;
}

void quickSort(int p, int q, char **x){
    int i = p, j = q;
    char *s = x[(p+q)/2];
    while(i <= j){
        for(; strcmp(x[i]+1, s+1) < 0; i++);
        for(; strcmp(x[j]+1, s+1) > 0; j--);
        if(i <= j){
            char *p = x[i];
            x[i] = x[j];
            x[j] = p;
            i++;
            j--;
        }
    }
    if(i < q)
        quickSort(i, q, x);
    if(j > p)
        quickSort(p, j, x);
}

int binary1(int p, int q, char **x, char c, int k, int* l){
    if(l[p] < k || x[p][k] >= c)
        return p;
    int s;
    while(p <= q){
        s = (p+q)/2;
        if(l[s] < k){
            p = s + 1;
        }
        else{
            if(x[s][k] >= c && x[s-1][k] < c)
                return s;
            else if(x[s][k] < c)
                p = s + 1;
            else
                q = s - 1;
        }
    }
    return q+1;
}

int binary2(int p, int q, char **x, char c, int k, int* l){
    if(l[q] < k || x[q][k] <= c)
        return q;
    int s;
    while(p <= q){
        s = (p+q)/2;
        if(l[s] < k){
            if(l[s+1] >= k || x[s+1][k] > c)
                return s;
        }
        else{
            if(x[s][k] <= c && x[s+1][k] > c)
                return s;
            else if(x[s][k] > c)
                q = s - 1;
            else
                p = s + 1;
        }
    }
    return p-1;
}

int rekurzija(int N, char *A, int M, int *L, char** B, int k){
    if(k%N == 1 && k != 1)
        return 0;
    int p = 1, q = M;
    for(int i = 1; ; i++){
        p = binary1(p, q, B, A[(k+i-2)%N+1], i, L);
        q = binary2(p, q, B, A[(k+i-2)%N+1], i, L);
    }
    int d = -1;
    for(int i = p; i <= q; i++){
        int temp = rekurzija(N,A,M,L,B,k+L[i]);
        if((d < 0 || temp + 1 < d) && temp >= 0)
            d = temp;
    }
    return d;
}

bool a_(int n, char *a){
    for(int i = 1; i <= n; i++)
        if(a[i] != 'a')
            return false;
    return true;
}

int Resi(int N, char* A, int M, int* L, char** B){
    if(a_(N, A)){
        int *t = new int[M+1], k = 1, *p = new int[N+1];
        for(int i = 1; i <= M; i++)
            if(a_(L[i], B[i])){
                t[k] = i;
                k++;
            }
        for(int i = 1; i <= N; i++)
            p[i] = -1;
        for(int i = 1; i < k; i++)
            p[t[i]] = 1;
        for(int i = 1; i <= N; i++)
            for(int j = 1; j < k; j++)
                if(i+t[j] <= N && (p[i+t[j]] > p[i]+1 || p[i+t[j]] == -1))
                    p[i+t[j]] = p[i]+1;
        int d = -1;
        if(p[N]!=0)
            d = p[N];
        delete[] t;
        delete[] p;
        return d;
    }
    quickSort(1, M, B);
    int d = -1;
	for(int i = 0; i < N; i++){
        int temp = rekurzija(N, A, M, L, B, 1);
        if(d >= 0 && temp < d)
            d = temp;
        shift(N, A);
	}
	return d;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cerr.tie(nullptr);

	string a;
	int m;
	vector<string> b;

	cin >> a >> m;
	b.resize(m);
	for (auto& s : b)
		cin >> s;

	int n = a.size();
	char* A = new char[n+2];
	A[0] = A[n+1] = 0;
	copy(a.begin(), a.end(), A+1);

    char** B = new char*[m+1];
	int* L = new int[m+1];

	for (int i=1; i<=m; i++) {
		L[i] = b[i-1].size();
		B[i] = new char[L[i] + 2];
		B[i][0] = B[i][L[i]+1] = 0;
		copy(b[i-1].begin(), b[i-1].end(), B[i]+1);
	}

	cout << Resi(n, A, m, L, B) << '\n';
	return 0;
}