#include <queue>
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int tr = 1, best = 1e9;
struct node {
    int p[30];
    bool word;

    node() {
        for (int i = 0; i < 26; i++) p[i] = 0;
    }
} trie[1000005];

struct stanje {
    int score, cvor, ind;

    stanje(int score, int cvor, int ind) : score(score), cvor(cvor), ind(ind) {}

    bool operator <(const stanje other) const {
        return score > other.score;
    }
};

int trystr(int N, char* A, int M, int* L, char** B, int l, int r) {
    //cerr << l << " " << r << " ";
    priority_queue<stanje> q;
    q.push(stanje(1, 0, l));
    while (!q.empty()) {
        stanje tren = q.top();
        if (tren.score > 2*N || tren.score > best) { /*cerr << -1 << endl;*/ return -1; }
        q.pop();
        if (trie[tren.cvor].word && tren.ind == l) { /*cerr << tren.score << endl;*/ return tren.score; }
        if (trie[tren.cvor].p[A[tren.ind]-'a'] != 0)
            q.push(stanje(tren.score, trie[tren.cvor].p[A[tren.ind]-'a'], tren.ind == r ? l : tren.ind+1));
        if (trie[tren.cvor].word)
            q.push(stanje(tren.score+1, 0, tren.ind));
    }
    //cerr << -1 << endl;
    return -1;
}

void maketrie(int M, int* L, char** B) {
    for (int i = 1; i <= M; i++) {
        int cvor = 0;
        for (int j = 1; j <= L[i]; j++) {
            if (trie[cvor].p[B[i][j]-'a'] == 0) {
                trie[cvor].p[B[i][j]-'a'] = tr++;
            }
            cvor = trie[cvor].p[B[i][j]-'a'];
        }
        trie[cvor].word = true;
    }
}

int dfs(int x) {
    for (int i = 0; i < 26; i++) cerr << trie[x].p[i] << " ";
    cerr << endl << trie[x].word << endl;
    for (int i = 0; i < 26; i++)
        if (trie[x].p[i] != 0) dfs(trie[x].p[i]);
}

bool cmp(pair<int, int> a, pair<int, int> b) {
    return a.second-a.first < b.second-b.first;
}

int Resi(int N, char* A, int M, int* L, char** B) {
    bool samoaovi = true;
    for (int i = 1; i <= N; i++) if (A[i] != 'a') samoaovi = false;
    if (samoaovi) {
        for (int i = 1; i <= M; i++) {
            bool samoa = true;
            for (int j = 1; j <= L[i] && samoa; j++) {
                if (B[i][j] != 'a') samoa = false;
            }
            if (samoa) return 1;
        }
        return -1;
    } else {
        maketrie(M, L, B);
        vector<pair<int, int>> off;
        //dfs(0);
        for (int i = 1; i <= N; i++) {
            for (int j = i; j <= N; j++) {
                bool dobro = true;
                for (int k = 1; i-k > 0 && dobro; k++)
                    if (A[i-k] != A[j-(j-i+k)%(j-i+1)]) dobro = false;
                for (int k = 1; j+k <= N && dobro; k++)
                    if (A[j+k] != A[i+(k-1)%(j-i+1)]) dobro = false;
                if (dobro) {
                    /*int res = trystr(N, A, M, L, B, i, j);
                    if (res != -1) best = min(best, res);*/
                    off.push_back(make_pair(i, j));
                }
            }
        }
        sort(off.begin(), off.end(), cmp);
        for (int i = 0; i < off.size(); i++) {
            int res = trystr(N, A, M, L, B, off[i].first, off[i].second);
            if (res != -1) best = min(best, res);
        }
        for (int i = 0; i < N; i++) {
            char tmp = A[1];
            for (int j = 1; j < N; j++) A[j] = A[j+1];//, cerr << A[j];
            A[N] = tmp;
            //cerr << A[N] << endl;
            int res = trystr(N, A, M, L, B, 1, N);
            if (res != -1) best = min(best, res);
        }
        return best == 1e9 ? -1 : best;
    }
}

/*

bba
2
ba
abb

*/